/[gentoo-x86]/eclass/kde4-base.eclass
Gentoo

Diff of /eclass/kde4-base.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.9 Revision 1.121
1# Copyright 2007-2008 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.9 2008/04/06 21:36:53 zlin Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.121 2012/08/19 11:12:35 johu Exp $
4 4
5# @ECLASS: kde4-base.eclass 5# @ECLASS: kde4-base.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: This eclass provides functions for kde 4.0 ebuilds 8# @BLURB: This eclass provides functions for kde 4.X ebuilds
9# @DESCRIPTION: 9# @DESCRIPTION:
10# The kde4-base.eclass provides support for building KDE4 monolithic ebuilds 10# The kde4-base.eclass provides support for building KDE4 based ebuilds
11# and KDE4 applications. 11# and KDE4 applications.
12# 12#
13# NOTE: This eclass uses the SLOT dependencies from EAPI="1" or compatible, 13# NOTE: KDE 4 ebuilds currently support EAPI "3". This will be reviewed
14# hence you must define EAPI="1" in the ebuild, before inheriting any eclasses. 14# over time as new EAPI versions are approved.
15 15
16inherit base eutils multilib cmake-utils kde4-functions 16# @ECLASS-VARIABLE: KDE_SELINUX_MODULE
17# @DESCRIPTION:
18# If set to "none", do nothing.
19# For any other value, add selinux to IUSE, and depending on that useflag
20# add a dependency on sec-policy/selinux-${KDE_SELINUX_MODULE} to (R)DEPEND
21: ${KDE_SELINUX_MODULE:=none}
17 22
18EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_test src_install pkg_postinst pkg_postrm 23# @ECLASS-VARIABLE: VIRTUALDBUS_TEST
24# @DESCRIPTION:
25# If defined, launch and use a private dbus session during src_test.
19 26
20kde4-base_set_qt_dependencies() { 27# @ECLASS-VARIABLE: VIRTUALX_REQUIRED
21 local qt qtcore qtgui qt3support qtsvg qttest qtopengl qtdepend qtopengldepend 28# @DESCRIPTION:
29# For proper description see virtualx.eclass manpage.
30# Here we redefine default value to be manual, if your package needs virtualx
31# for tests you should proceed with setting VIRTUALX_REQUIRED=test.
32: ${VIRTUALX_REQUIRED:=manual}
22 33
23 # use dependencies 34inherit kde4-functions toolchain-funcs fdo-mime flag-o-matic gnome2-utils base virtualx versionator eutils multilib
24 case "${EAPI}" in 35
25 kdebuild-1) 36if [[ ${KDE_BUILD_TYPE} = live ]]; then
26 qt="[accessibility][dbus][debug?][gif][jpeg][png][qt3support][ssl][zlib]" 37 case ${KDE_SCM} in
27 qtcore="[debug?][qt3support][ssl]" 38 svn) inherit subversion ;;
28 qtgui="[accessibility][dbus][debug?]" 39 git) inherit git-2 ;;
29 qt3support="[accessibility][debug?]"
30 qtsvg="[debug?]"
31 qttest="[debug?]"
32 qtopengl="[debug?]"
33 case "${OPENGL_REQUIRED}" in
34 always)
35 qt="${qt}[opengl]"
36 ;;
37 optional)
38 qt="${qt}[opengl?]"
39 ;;
40 esac
41 ;;
42 esac 40 esac
41fi
43 42
44 # split qt 43# @ECLASS-VARIABLE: CMAKE_REQUIRED
45 qtdepend=" 44# @DESCRIPTION:
46 x11-libs/qt-core:4${qtcore} 45# Specify if cmake buildsystem is being used. Possible values are 'always' and 'never'.
47 x11-libs/qt-gui:4${qtgui} 46# Please note that if it's set to 'never' you need to explicitly override following phases:
48 x11-libs/qt-qt3support:4${qt3support} 47# src_configure, src_compile, src_test and src_install.
49 x11-libs/qt-svg:4${qtsvg} 48# Defaults to 'always'.
50 x11-libs/qt-test:4${qttest}" 49: ${CMAKE_REQUIRED:=always}
51 qtopengldepend="x11-libs/qt-opengl:4${qtopengl}" 50if [[ ${CMAKE_REQUIRED} = always ]]; then
51 buildsystem_eclass="cmake-utils"
52 export_fns="src_configure src_compile src_test src_install"
53fi
52 54
53 # allow monolithic qt for PV < 4.1 55# @ECLASS-VARIABLE: KDE_MINIMAL
56# @DESCRIPTION:
57# This variable is used when KDE_REQUIRED is set, to specify required KDE minimal
58# version for apps to work. Currently defaults to 4.4
59# One may override this variable to raise version requirements.
60# Note that it is fixed to ${PV} for kde-base packages.
61KDE_MINIMAL="${KDE_MINIMAL:-4.4}"
62
63# Set slot for KDEBASE known packages
64case ${KDEBASE} in
65 kde-base)
66 SLOT=4
67 KDE_MINIMAL="${PV}"
68 ;;
69 kdevelop)
70 if [[ ${KDE_BUILD_TYPE} = live ]]; then
71 # @ECLASS-VARIABLE: KDEVELOP_VERSION
72 # @DESCRIPTION:
73 # Specifies KDevelop version. Default is 4.0.0 for tagged packages and 9999 for live packages.
74 # Applies to KDEBASE=kdevelop only.
75 KDEVELOP_VERSION="${KDEVELOP_VERSION:-9999}"
76 # @ECLASS-VARIABLE: KDEVPLATFORM_VERSION
77 # @DESCRIPTION:
78 # Specifies KDevplatform version. Default is 1.0.0 for tagged packages and 9999 for live packages.
79 # Applies to KDEBASE=kdevelop only.
80 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-9999}"
81 else
54 case "${PV}" in 82 case ${PN} in
55 scm|9999.4|4.1*) : ;; 83 kdevelop|quanta)
84 KDEVELOP_VERSION=${PV}
85 KDEVPLATFORM_VERSION="$(($(get_major_version)-3)).$(get_after_major_version)"
86 ;;
87 kdevplatform|kdevelop-php*)
88 KDEVELOP_VERSION="$(($(get_major_version)+3)).$(get_after_major_version)"
89 KDEVPLATFORM_VERSION=${PV}
90 ;;
56 *) 91 *)
57 qtdepend="|| ( ( ${qtdepend} ) >=x11-libs/qt-4.3.3:4${qt} )" 92 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.0.0}"
58 qtopengldepend="|| ( ${qtopengldepend} >=x11-libs/qt-4.3.3:4 )" 93 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-1.0.0}"
94 esac
95 fi
96 SLOT="4"
59 ;; 97 ;;
60 esac 98esac
61 99
62 # opengl dependencies 100inherit ${buildsystem_eclass}
63 case "${OPENGL_REQUIRED}" in
64 always)
65 qtdepend="${qtdepend}
66 ${qtopengldepend}"
67 ;;
68 optional)
69 IUSE="${IUSE} opengl"
70 qtdepend="${qtdepend}
71 opengl? ( ${qtopengldepend} )"
72 ;;
73 *)
74 OPENGL_REQUIRED="never"
75 ;;
76 esac
77 101
78 COMMONDEPEND="${COMMONDEPEND} ${qtdepend}" 102EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare ${export_fns} pkg_preinst pkg_postinst pkg_postrm
79}
80kde4-base_set_qt_dependencies
81 103
82DEPEND="${DEPEND} ${COMMONDEPEND} 104unset buildsystem_eclass
83 >=dev-util/cmake-2.4.7-r1 105unset export_fns
84 dev-util/pkgconfig 106
85 x11-libs/libXt 107# @ECLASS-VARIABLE: DECLARATIVE_REQUIRED
86 x11-proto/xf86vidmodeproto" 108# @DESCRIPTION:
87RDEPEND="${RDEPEND} ${COMMONDEPEND}" 109# Is qt-declarative required? Possible values are 'always', 'optional' and 'never'.
110# This variable must be set before inheriting any eclasses. Defaults to 'never'.
111DECLARATIVE_REQUIRED="${DECLARATIVE_REQUIRED:-never}"
112
113# @ECLASS-VARIABLE: QTHELP_REQUIRED
114# @DESCRIPTION:
115# Is qt-assistant required? Possible values are 'always', 'optional' and 'never'.
116# This variable must be set before inheriting any eclasses. Defaults to 'never'.
117QTHELP_REQUIRED="${QTHELP_REQUIRED:-never}"
88 118
89# @ECLASS-VARIABLE: OPENGL_REQUIRED 119# @ECLASS-VARIABLE: OPENGL_REQUIRED
90# @DESCRIPTION: 120# @DESCRIPTION:
91# Is qt-opengl required? Possible values are 'always', 'optional' and 'never'. 121# Is qt-opengl required? Possible values are 'always', 'optional' and 'never'.
92# This variable must be set before inheriting any eclasses. Defaults to 'never'. 122# This variable must be set before inheriting any eclasses. Defaults to 'never'.
93OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}" 123OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}"
94 124
125# @ECLASS-VARIABLE: MULTIMEDIA_REQUIRED
126# @DESCRIPTION:
127# Is qt-multimedia required? Possible values are 'always', 'optional' and 'never'.
128# This variable must be set before inheriting any eclasses. Defaults to 'never'.
129MULTIMEDIA_REQUIRED="${MULTIMEDIA_REQUIRED:-never}"
130
95# @ECLASS-VARIABLE: CPPUNIT_REQUIRED 131# @ECLASS-VARIABLE: CPPUNIT_REQUIRED
96# @DESCRIPTION: 132# @DESCRIPTION:
97# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'. 133# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'.
98# This variable must be set before inheriting any eclasses. Defaults to 'never'. 134# This variable must be set before inheriting any eclasses. Defaults to 'never'.
99CPPUNIT_REQUIRED="${CPPUNIT_REQUIRED:-never}" 135CPPUNIT_REQUIRED="${CPPUNIT_REQUIRED:-never}"
100 136
101case "${CPPUNIT_REQUIRED}" in 137# @ECLASS-VARIABLE: KDE_REQUIRED
138# @DESCRIPTION:
139# Is kde required? Possible values are 'always', 'optional' and 'never'.
140# This variable must be set before inheriting any eclasses. Defaults to 'always'
141# If set to 'always' or 'optional', KDE_MINIMAL may be overriden as well.
142# Note that for kde-base packages this variable is fixed to 'always'.
143KDE_REQUIRED="${KDE_REQUIRED:-always}"
144
145# @ECLASS-VARIABLE: KDE_HANDBOOK
146# @DESCRIPTION:
147# Set to enable handbook in application. Possible values are 'always', 'optional'
148# (handbook USE flag) and 'never'.
149# This variable must be set before inheriting any eclasses. Defaults to 'never'.
150# It adds default handbook dirs for kde-base packages to KMEXTRA and in any case it
151# ensures buildtime and runtime dependencies.
152KDE_HANDBOOK="${KDE_HANDBOOK:-never}"
153
154# @ECLASS-VARIABLE: KDE_LINGUAS_LIVE_OVERRIDE
155# @DESCRIPTION:
156# Set this varible if you want your live package to manage its
157# translations. (Mostly all kde ebuilds does not ship documentation
158# and translations in live ebuilds)
159if [[ ${KDE_BUILD_TYPE} == live && -z ${KDE_LINGUAS_LIVE_OVERRIDE} ]]; then
160 # Kdebase actualy provides the handbooks even for live stuff
161 [[ ${KDEBASE} == kde-base ]] || KDE_HANDBOOK=never
162 KDE_LINGUAS=""
163fi
164
165# Setup packages inheriting this eclass
166case ${KDEBASE} in
167 kde-base)
168 HOMEPAGE="http://www.kde.org/"
169 LICENSE="GPL-2"
170 if [[ ${KDE_BUILD_TYPE} = live && -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
171 # Disable tests for live ebuilds by default
172 RESTRICT+=" test"
173 fi
174
175 # Only add the kdeprefix USE flag for older versions, to help
176 # non-portage package managers handle the upgrade
177 if [[ ${PV} < 4.6.4 && ( ( ${KMNAME} != kdepim && ${PN} != kdepim-runtime ) || ${PV} < 4.6 ) ]]; then
178 IUSE+=" kdeprefix"
179 fi
180
181 # This code is to prevent portage from searching GENTOO_MIRRORS for
182 # packages that will never be mirrored. (As they only will ever be in
183 # the overlay).
184 case ${PV} in
185 *9999* | 4.?.[6-9]?)
186 RESTRICT+=" mirror"
187 ;;
188 esac
189 ;;
190 kdevelop)
191 HOMEPAGE="http://www.kdevelop.org/"
192 LICENSE="GPL-2"
193 ;;
194esac
195
196# @ECLASS-VARIABLE: QT_MINIMAL
197# @DESCRIPTION:
198# Determine version of qt we enforce as minimal for the package.
199if version_is_at_least 4.8.50 "${KDE_MINIMAL}"; then
200 # Upstream has added an *undeclared* dependency on Qt 4.8...
201 QT_MINIMAL="${QT_MINIMAL:-4.8.0}"
202else
203 QT_MINIMAL="${QT_MINIMAL:-4.7.4}"
204fi
205
206# Declarative dependencies
207qtdeclarativedepend="
208 >=x11-libs/qt-declarative-${QT_MINIMAL}:4
209"
210case ${DECLARATIVE_REQUIRED} in
102 always) 211 always)
103 DEPEND="${DEPEND} dev-util/cppunit" 212 COMMONDEPEND+=" ${qtdeclarativedepend}"
104 ;; 213 ;;
105 optional) 214 optional)
106 IUSE="${IUSE} test" 215 IUSE+=" declarative"
107 DEPEND="${DEPEND} 216 COMMONDEPEND+=" declarative? ( ${qtdeclarativedepend} )"
108 test? ( dev-util/cppunit )"
109 ;; 217 ;;
218 *) ;;
219esac
220unset qtdeclarativedepend
221
222# QtHelp dependencies
223qthelpdepend="
224 >=x11-libs/qt-assistant-${QT_MINIMAL}:4
225"
226case ${QTHELP_REQUIRED} in
227 always)
228 COMMONDEPEND+=" ${qthelpdepend}"
229 ;;
230 optional)
231 IUSE+=" qthelp"
232 COMMONDEPEND+=" qthelp? ( ${qthelpdepend} )"
233 ;;
234esac
235unset qthelpdepend
236
237# OpenGL dependencies
238qtopengldepend="
239 >=x11-libs/qt-opengl-${QT_MINIMAL}:4
240"
241case ${OPENGL_REQUIRED} in
242 always)
243 COMMONDEPEND+=" ${qtopengldepend}"
244 ;;
245 optional)
246 IUSE+=" opengl"
247 COMMONDEPEND+=" opengl? ( ${qtopengldepend} )"
248 ;;
249 *) ;;
250esac
251unset qtopengldepend
252
253# MultiMedia dependencies
254qtmultimediadepend="
255 >=x11-libs/qt-multimedia-${QT_MINIMAL}:4
256"
257case ${MULTIMEDIA_REQUIRED} in
258 always)
259 COMMONDEPEND+=" ${qtmultimediadepend}"
260 ;;
261 optional)
262 IUSE+=" multimedia"
263 COMMONDEPEND+=" multimedia? ( ${qtmultimediadepend} )"
264 ;;
265 *) ;;
266esac
267unset qtmultimediadepend
268
269# CppUnit dependencies
270cppuintdepend="
271 dev-util/cppunit
272"
273case ${CPPUNIT_REQUIRED} in
274 always)
275 DEPEND+=" ${cppuintdepend}"
276 ;;
277 optional)
278 IUSE+=" test"
279 DEPEND+=" test? ( ${cppuintdepend} )"
280 ;;
281 *) ;;
282esac
283unset cppuintdepend
284
285# KDE dependencies
286# Qt accessibility classes are needed in various places, bug 325461
287kdecommondepend="
288 dev-lang/perl
289 >=x11-libs/qt-core-${QT_MINIMAL}:4[qt3support,ssl]
290 >=x11-libs/qt-dbus-${QT_MINIMAL}:4
291 >=x11-libs/qt-gui-${QT_MINIMAL}:4[accessibility,dbus]
292 >=x11-libs/qt-qt3support-${QT_MINIMAL}:4[accessibility]
293 >=x11-libs/qt-script-${QT_MINIMAL}:4
294 >=x11-libs/qt-sql-${QT_MINIMAL}:4[qt3support]
295 >=x11-libs/qt-svg-${QT_MINIMAL}:4
296 >=x11-libs/qt-test-${QT_MINIMAL}:4
297 >=x11-libs/qt-webkit-${QT_MINIMAL}:4
298 !aqua? (
299 x11-libs/libXext
300 x11-libs/libXt
301 x11-libs/libXxf86vm
302 x11-libs/libXcomposite
303 x11-libs/libxkbfile
304 )
305"
306
307if [[ ${PN} != kdelibs ]]; then
308 kdecommondepend+=" $(add_kdebase_dep kdelibs)"
309 if [[ ${KDEBASE} = kdevelop ]]; then
310 if [[ ${PN} != kdevplatform ]]; then
311 # @ECLASS-VARIABLE: KDEVPLATFORM_REQUIRED
312 # @DESCRIPTION:
313 # Specifies whether kdevplatform is required. Possible values are 'always' (default) and 'never'.
314 # Applies to KDEBASE=kdevelop only.
315 KDEVPLATFORM_REQUIRED="${KDEVPLATFORM_REQUIRED:-always}"
316 case ${KDEVPLATFORM_REQUIRED} in
317 always)
318 kdecommondepend+="
319 >=dev-util/kdevplatform-${KDEVPLATFORM_VERSION}
320 "
321 ;;
322 *) ;;
323 esac
324 fi
325 fi
326fi
327
328kdedepend="
329 dev-util/automoc
330 virtual/pkgconfig
331 !aqua? (
332 >=x11-libs/libXtst-1.1.0
333 x11-proto/xf86vidmodeproto
334 )
335"
336
337kderdepend=""
338
339# all packages needs oxygen icons for basic iconset
340if [[ ${PN} != oxygen-icons ]]; then
341 kderdepend+=" $(add_kdebase_dep oxygen-icons)"
342fi
343
344# add a dependency over kde-l10n if EAPI4 or better is around
345if [[ ${KDEBASE} != "kde-base" && -n ${KDE_LINGUAS} && ${EAPI:-0} != 3 ]]; then
346 for _lingua in ${KDE_LINGUAS}; do
347 # if our package has lignuas, pull in kde-l10n with selected lingua enabled,
348 # but only for selected ones.
349 # this can't be done on one line because if user doesn't use any localisation
350 # then he is probably not interested in kde-l10n at all.
351 kderdepend+="
352 linguas_${_lingua}? ( $(add_kdebase_dep kde-l10n "linguas_${_lingua}(+)") )
353 "
354 done
355 unset _lingua
356fi
357
358kdehandbookdepend="
359 app-text/docbook-xml-dtd:4.2
360 app-text/docbook-xsl-stylesheets
361"
362kdehandbookrdepend="
363 $(add_kdebase_dep kdelibs 'handbook')
364"
365case ${KDE_HANDBOOK} in
366 always)
367 kdedepend+=" ${kdehandbookdepend}"
368 [[ ${PN} != kdelibs ]] && kderdepend+=" ${kdehandbookrdepend}"
369 ;;
370 optional)
371 IUSE+=" +handbook"
372 kdedepend+=" handbook? ( ${kdehandbookdepend} )"
373 [[ ${PN} != kdelibs ]] && kderdepend+=" handbook? ( ${kdehandbookrdepend} )"
374 ;;
375 *) ;;
376esac
377unset kdehandbookdepend kdehandbookrdepend
378
379case ${KDE_SELINUX_MODULE} in
380 none) ;;
110 *) 381 *)
111 CPPUNIT_REQUIRED="never" 382 IUSE+=" selinux"
383 kdecommondepend+=" selinux? ( sec-policy/selinux-${KDE_SELINUX_MODULE} )"
112 ;; 384 ;;
113esac 385esac
114 386
115# @ECLASS-VARIABLE: NEED_KDE 387case ${KDE_REQUIRED} in
116# @DESCRIPTION: 388 always)
117# This variable sets the version of KDE4 which will be used by the eclass. 389 IUSE+=" aqua"
118# This variable must be set by the ebuild, for all categories except for "kde-base". 390 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" ${kdecommondepend}"
119# For kde-base packages, if it is not set by the ebuild, 391 [[ -n ${kdedepend} ]] && DEPEND+=" ${kdedepend}"
120# it's assumed that the required KDE4 version is the latest, non-live, available. 392 [[ -n ${kderdepend} ]] && RDEPEND+=" ${kderdepend}"
121#
122# @CODE
123# Acceptable values are:
124# - latest - Use latest version in the portage tree
125# Default for kde-base ebuilds. Banned for ebuilds not part of kde or koffice.
126# - svn - Use svn release (live ebuilds)
127# - :SLOT - Use any version in the SLOT specified in the NEED_KDE value.
128# - VERSION_NUMBER - Use the minimum KDE4 version specified in the NEED_KDE value.
129# - VERSION_NUMBER:SLOT - Use the minimum KDE4 version and the SLOT specified in the NEED_KDE value.
130# - none - Let the ebuild handle SLOT, kde dependencies, KDEDIR, ...
131# @CODE
132#
133# Note: There is no default NEED_KDE for ebuilds not in kde-base or part of
134# koffice, so you must set it explicitly in the ebuild, in all other cases.
135if [[ -z ${NEED_KDE} ]]; then
136 if [[ -n ${KDEBASE} ]]; then
137 NEED_KDE="latest"
138 else
139 die "kde4-base.eclass inherited but NEED_KDE not defined - broken ebuild"
140 fi
141fi
142export NEED_KDE
143
144case ${NEED_KDE} in
145 latest)
146 # Should only be used by 'kde-base'-ebuilds
147 if [[ "${KDEBASE}" == "kde-base" ]]; then
148 case ${PV} in
149 3.9*) _kdedir="3.9" ;;
150 4*) _kdedir="4.0" ;;
151 *) die "NEED_KDE=latest not supported for PV=${PV}" ;;
152 esac
153 _operator=">="
154 _pv="-${PV}:kde-4"
155 else
156 _kdedir="4.0"
157 _pv=":kde-4"
158 fi
159 ;; 393 ;;
160 scm|svn|9999*|:kde-svn) 394 optional)
161 _kdedir="svn" 395 IUSE+=" aqua kde"
162 _pv=":kde-svn" 396 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" kde? ( ${kdecommondepend} )"
163 export NEED_KDE="svn" 397 [[ -n ${kdedepend} ]] && DEPEND+=" kde? ( ${kdedepend} )"
398 [[ -n ${kderdepend} ]] && RDEPEND+=" kde? ( ${kderdepend} )"
164 ;; 399 ;;
165 *:kde-svn) 400 *) ;;
166 _kdedir="svn"
167 _operator=">="
168 _pv="-${NEED_KDE}"
169 export NEED_KDE="svn"
170 ;;
171 # The ebuild handles dependencies, KDEDIR, SLOT.
172 none)
173 :
174 ;;
175 # NEED_KDE=":${SLOT}"
176 :kde-4)
177 _kdedir="4.0"
178 _pv="${NEED_KDE}"
179 ;;
180 # NEED_KDE="${PV}:${SLOT}"
181 *:kde-4)
182 _kdedir="4.0"
183 _operator=">="
184 _pv="-${NEED_KDE}"
185 ;;
186 3.9*)
187 _kdedir="3.9"
188 _operator=">="
189 _pv="-${NEED_KDE}:kde-4"
190 ;;
191 4*)
192 _kdedir="4.0"
193 _operator=">="
194 _pv="-${NEED_KDE}:kde-4"
195 ;;
196 *) die "NEED_KDE=${NEED_KDE} currently not supported."
197 ;;
198esac 401esac
199 402
200if [[ ${NEED_KDE} != none ]]; then 403unset kdecommondepend kdedepend kderdepend
201 KDEDIR="/usr/kde/${_kdedir}"
202 KDEDIRS="/usr:/usr/local:${KDEDIR}"
203 404
204 if [[ -n ${KDEBASE} ]]; then 405debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: COMMONDEPEND is ${COMMONDEPEND}"
205 if [[ ${NEED_KDE} = svn ]]; then 406debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: DEPEND (only) is ${DEPEND}"
206 SLOT="kde-svn" 407debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: RDEPEND (only) is ${RDEPEND}"
207 else
208 SLOT="kde-4"
209 fi
210 fi
211 408
212 # We only need to add the dependencies if ${PN} is not "kdelibs" or "kdepimlibs" 409# Accumulate dependencies set by this eclass
213 if [[ ${PN} != "kdelibs" ]]; then
214 DEPEND="${DEPEND} 410DEPEND+=" ${COMMONDEPEND}"
215 ${_operator}kde-base/kdelibs${_pv}"
216 RDEPEND="${RDEPEND} 411RDEPEND+=" ${COMMONDEPEND}"
217 ${_operator}kde-base/kdelibs${_pv}" 412unset COMMONDEPEND
218 if [[ ${PN} != "kdepimlibs" ]]; then
219 DEPEND="${DEPEND}
220 ${_operator}kde-base/kdepimlibs${_pv}"
221 RDEPEND="${RDEPEND}
222 ${_operator}kde-base/kdepimlibs${_pv}"
223 fi
224 fi
225
226 unset _operator _pv _kdedir
227fi
228 413
229# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a 414# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a
230# koffice ebuild, the URI should be set in the ebuild itself 415# kdevelop ebuild, the URI should be set in the ebuild itself
231if [[ -n ${KDEBASE} ]]; then 416_calculate_src_uri() {
417 debug-print-function ${FUNCNAME} "$@"
418
419 local _kmname _kmname_pv
420
421 # we calculate URI only for known KDEBASE modules
422 [[ -n ${KDEBASE} ]] || return
423
424 # calculate tarball module name
232 if [[ -n ${KMNAME} ]]; then 425 if [[ -n ${KMNAME} ]]; then
426 # fixup kdebase-apps name
427 case ${KMNAME} in
428 kdebase-apps)
429 _kmname="kdebase" ;;
430 *)
233 _kmname=${KMNAME} 431 _kmname="${KMNAME}" ;;
432 esac
234 else 433 else
235 _kmname=${PN} 434 _kmname=${PN}
236 fi 435 fi
237 _kmname_pv="${_kmname}-${PV}" 436 _kmname_pv="${_kmname}-${PV}"
238 if [[ ${NEED_KDE} != "svn" ]]; then
239 case ${KDEBASE} in 437 case ${KDEBASE} in
240 kde-base) 438 kde-base)
241 case ${PV} in 439 case ${PV} in
440 4.4.11.1)
441 # KDEPIM 4.4, special case
442 # TODO: Remove this part when KDEPIM 4.4 gets out of the tree
443 SRC_URI="mirror://kde/stable/kdepim-${PV}/src/${_kmname_pv}.tar.bz2" ;;
444 4.[89].8[05] | 4.[89].9[0235678])
445 # Unstable KDE SC releases
446 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.xz" ;;
447 4.[1234567].[12345])
448 # Stable KDE SC with old .bz2 support
242 *) SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2";; 449 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2" ;;
450 *)
451 # Stable KDE SC releases
452 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.xz" ;;
243 esac 453 esac
244 ;; 454 ;;
245 koffice) 455 kdevelop|kdevelop-php*|kdevplatform)
246 SRC_URI="mirror://kde/unstable/${_kmname_pv}/src/${_kmname_pv}.tar.bz2" 456 case ${KDEVELOP_VERSION} in
457 4.[12].[6-9]*) SRC_URI="mirror://kde/unstable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.bz2" ;;
458 *) SRC_URI="mirror://kde/stable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.bz2" ;;
459 esac
247 ;; 460 ;;
461 esac
462}
463
464_calculate_live_repo() {
465 debug-print-function ${FUNCNAME} "$@"
466
467 SRC_URI=""
468 case ${KDE_SCM} in
469 svn)
470 # Determine branch URL based on live type
471 local branch_prefix
472 case ${PV} in
473 9999*)
474 # trunk
475 branch_prefix="trunk/KDE"
476 ;;
477 *)
478 # branch
479 branch_prefix="branches/KDE/$(get_kde_version)"
480 # @ECLASS-VARIABLE: ESVN_PROJECT_SUFFIX
481 # @DESCRIPTION
482 # Suffix appended to ESVN_PROJECT depending on fetched branch.
483 # Defaults is empty (for -9999 = trunk), and "-${PV}" otherwise.
484 ESVN_PROJECT_SUFFIX="-${PV}"
485 ;;
486 esac
487 # @ECLASS-VARIABLE: ESVN_MIRROR
488 # @DESCRIPTION:
489 # This variable allows easy overriding of default kde mirror service
490 # (anonsvn) with anything else you might want to use.
491 ESVN_MIRROR=${ESVN_MIRROR:=svn://anonsvn.kde.org/home/kde}
492 # Split ebuild, or extragear stuff
493 if [[ -n ${KMNAME} ]]; then
494 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}"
495 if [[ -z ${KMNOMODULE} ]] && [[ -z ${KMMODULE} ]]; then
496 KMMODULE="${PN}"
497 fi
498 # Split kde-base/ ebuilds: (they reside in trunk/KDE)
499 case ${KMNAME} in
500 kdebase-*)
501 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdebase/${KMNAME#kdebase-}"
502 ;;
503 kdelibs-*)
504 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdelibs/${KMNAME#kdelibs-}"
505 ;;
506 kdereview*)
507 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
508 ;;
509 kdesupport)
510 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
511 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
512 ;;
513 kde*)
514 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${KMNAME}"
515 ;;
516 extragear*|playground*)
517 # Unpack them in toplevel dir, so that they won't conflict with kde4-meta
518 # build packages from same svn location.
519 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
520 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
521 ;;
522 *)
523 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
524 ;;
525 esac
526 else
527 # kdelibs, kdepimlibs
528 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${PN}"
529 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
530 fi
531 # @ECLASS-VARIABLE: ESVN_UP_FREQ
532 # @DESCRIPTION:
533 # This variable is used for specifying the timeout between svn synces
534 # for kde-base modules. Does not affect misc apps.
535 # Default value is 1 hour.
536 [[ ${KDEBASE} = kde-base ]] && ESVN_UP_FREQ=${ESVN_UP_FREQ:-1}
537 ;;
538 git)
539 local _kmname
540 # @ECLASS-VARIABLE: EGIT_MIRROR
541 # @DESCRIPTION:
542 # This variable allows easy overriding of default kde mirror service
543 # (anongit) with anything else you might want to use.
544 EGIT_MIRROR=${EGIT_MIRROR:=git://anongit.kde.org}
545
546 # @ECLASS-VARIABLE: EGIT_REPONAME
547 # @DESCRIPTION:
548 # This variable allows overriding of default repository
549 # name. Specify only if this differ from PN and KMNAME.
550 if [[ -n ${EGIT_REPONAME} ]]; then
551 # the repository and kmname different
552 _kmname=${EGIT_REPONAME}
553 elif [[ -n ${KMNAME} ]]; then
554 _kmname=${KMNAME}
555 else
556 _kmname=${PN}
557 fi
558
559 # default branching
560 [[ ${PV} != 9999* && ${KDEBASE} == kde-base ]] && \
561 EGIT_BRANCH="KDE/$(get_kde_version)"
562
563 # default repo uri
564 EGIT_REPO_URI="${EGIT_MIRROR}/${_kmname}"
565
566 debug-print "${FUNCNAME}: Repository: ${EGIT_REPO_URI}"
567 debug-print "${FUNCNAME}: Branch: ${EGIT_BRANCH}"
568 ;;
569 esac
570}
571
572case ${KDE_BUILD_TYPE} in
573 live) _calculate_live_repo ;;
574 *) _calculate_src_uri ;;
575esac
576
577debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}"
578
579# @ECLASS-VARIABLE: PREFIX
580# @DESCRIPTION:
581# Set the installation PREFIX for non kde-base applications. It defaults to /usr.
582# kde-base packages go into KDE4 installation directory (/usr).
583# No matter the PREFIX, package will be built against KDE installed in /usr.
584
585# @FUNCTION: kde4-base_pkg_setup
586# @DESCRIPTION:
587# Do some basic settings
588kde4-base_pkg_setup() {
589 debug-print-function ${FUNCNAME} "$@"
590
591 if has handbook ${IUSE} || has "+handbook" ${IUSE} && [ "${KDE_HANDBOOK}" != optional ] ; then
592 eqawarn "Handbook support is enabled via KDE_HANDBOOK=optional in the ebuild."
593 eqawarn "Please do not just set IUSE=handbook, as this leads to dependency errors."
594 fi
595
596 if use_if_iuse kdeprefix; then
597 eerror "Sorry, kdeprefix support has been removed."
598 eerror "Please remove kdeprefix from your USE variable."
599 die "kdeprefix support has been removed"
600 fi
601
602 if [[ ${CATEGORY}/${PN} != kde-base/kdelibs && ${CATEGORY}/${PN} != kde-base/kde-env ]] && \
603 { [[ ${KDE_REQUIRED} == always ]] || { [[ ${KDE_REQUIRED} == optional ]] && use kde; }; } && \
604 has_version kde-base/kdelibs[kdeprefix]; then
605 eerror "Sorry, kdeprefix support has been removed."
606 eerror "Please rebuild kdelibs without kdeprefix support."
607 die "kdeprefix support has been removed"
608 fi
609
610 # Don't set KDEHOME during compilation, it will cause access violations
611 unset KDEHOME
612
613 # Check if gcc compiler is fresh enough.
614 # In theory should be in pkg_pretend but we check it only for kdelibs there
615 # and for others we do just quick scan in pkg_setup because pkg_pretend
616 # executions consume quite some time.
617 # We can only do this for EAPI 4 or later because the MERGE_TYPE variable
618 # is otherwise undefined.
619 if [[ ${EAPI:-0} != 3 ]]; then
620 if [[ ${MERGE_TYPE} != binary ]]; then
621 [[ $(gcc-major-version) -lt 4 ]] || \
622 ( [[ $(gcc-major-version) -eq 4 && $(gcc-minor-version) -le 3 ]] ) \
623 && die "Sorry, but gcc-4.3 and earlier wont work for KDE (see bug 354837)."
624 fi
625 fi
626
627 KDEDIR=/usr
628 : ${PREFIX:=/usr}
629 EKDEDIR=${EPREFIX}/usr
630
631 # Point to correct QT plugins path
632 QT_PLUGIN_PATH="${EPREFIX}/usr/$(get_libdir)/kde4/plugins/"
633
634 # Fix XDG collision with sandbox
635 export XDG_CONFIG_HOME="${T}"
636}
637
638# @FUNCTION: kde4-base_src_unpack
639# @DESCRIPTION:
640# This function unpacks the source tarballs for KDE4 applications.
641kde4-base_src_unpack() {
642 debug-print-function ${FUNCNAME} "$@"
643
644 if [[ ${KDE_BUILD_TYPE} = live ]]; then
645 case ${KDE_SCM} in
646 svn)
647 migrate_store_dir
648 subversion_src_unpack
649 ;;
650 git)
651 git-2_src_unpack
652 ;;
248 esac 653 esac
249 fi
250 unset _kmname _kmname_pv
251fi
252
253debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}"
254debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: DEPEND ${DEPEND} - before blockers"
255
256# Monolithic ebuilds should add blockers for split ebuilds in the same slot.
257# If KMNAME is not set then this is not a split package
258if [[ -n ${KDEBASE} && -z ${KMNAME} ]]; then
259 for _x in $(get-child-packages ${CATEGORY}/${PN}); do
260 DEPEND="${DEPEND} !${_x}:${SLOT}"
261 RDEPEND="${RDEPEND} !${_x}:${SLOT}"
262 done
263 unset _x
264fi
265
266debug-print "${BASH_SOURCE} ${LINENO} ${ECLASS} ${FUNCNAME}: DEPEND ${DEPEND} - after blockers"
267
268# @ECLASS-VARIABLE: PREFIX
269# @DESCRIPTION:
270# Set the installation PREFIX. All kde-base ebuilds go into the KDE4 installation directory.
271# Applications installed by the other ebuilds go into /usr/ by default, this value
272# can be superseded by defining PREFIX before inheriting kde4-base.
273if [[ -n ${KDEBASE} ]]; then
274 PREFIX=${KDEDIR}
275else
276 # if PREFIX is not defined we set it to the default value of /usr
277 PREFIX="${PREFIX:-/usr}"
278fi
279
280debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SLOT ${SLOT} - KDEDIR ${KDEDIR} - KDEDIRS ${KDEDIRS}- PREFIX ${PREFIX} - NEED_KDE ${NEED_KDE}"
281
282# @FUNCTION: kde4-base_pkg_setup
283# @DESCRIPTION:
284# Adds flags needed by all of KDE 4 to $QT4_BUILT_WITH_USE_CHECK. Uses
285# kde4-functions_check_use from kde4-functions.eclass to print appropriate
286# errors and die if any required flags listed in $QT4_BUILT_WITH_USE_CHECK or
287# $KDE4_BUILT_WITH_USE_CHECK are missing.
288kde4-base_pkg_setup() {
289 debug-print-function $FUNCNAME "$@"
290
291 case "${EAPI}" in
292 kdebuild-1)
293 [[ -n ${QT4_BUILT_WITH_USE_CHECK} || -n ${KDE4_BUILT_WITH_USE_CHECK} ]] && \
294 die "built_with_use illegal in this EAPI!"
295 ;;
296 *)
297 # KDE4 applications require qt4 compiled with USE="accessibility dbus gif jpeg png qt3support ssl zlib".
298 if has_version '<x11-libs/qt-4.4_alpha:4'; then
299 QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} accessibility dbus gif jpeg png qt3support ssl zlib"
300 else 654 else
301 KDE4_BUILT_WITH_USE_CHECK="${KDE4_BUILT_WITH_USE_CHECK} 655 unpack ${A}
302 x11-libs/qt-core qt3support ssl
303 x11-libs/qt-gui accessibility dbus
304 x11-libs/qt-qt3support accessibility"
305 fi 656 fi
306
307 if has debug ${IUSE//+} && use debug; then
308 if has_version '<x11-libs/qt-4.4.0_alpha:4'; then
309 QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} debug"
310 else
311 KDE4_BUILT_WITH_USE_CHECK="${KDE4_BUILT_WITH_USE_CHECK}
312 x11-libs/qt-core:4 debug
313 x11-libs/qt-gui:4 debug
314 x11-libs/qt-qt3support:4 debug
315 x11-libs/qt-svg:4 debug
316 x11-libs/qt-test:4 debug"
317 if has opengl ${IUSE//+} && use opengl || [[ ${OPENGL_REQUIRED} == always ]]; then
318 KDE4_BUILT_WITH_USE_CHECK="${KDE4_BUILT_WITH_USE_CHECK}
319 x11-libs/qt-opengl:4 debug"
320 fi
321 fi
322 fi
323
324 if has opengl ${IUSE//+} && use opengl || [[ ${OPENGL_REQUIRED} == always ]]; then
325 if has_version '<x11-libs/qt-4.4.0_alpha:4'; then
326 QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} opengl"
327 fi
328 fi
329 kde4-functions_check_use
330 ;;
331 esac
332} 657}
333 658
334# @FUNCTION: kde4-base_apply_patches
335# @DESCRIPTION:
336# This function applies patches.
337#
338# If the directory ${WORKDIR}/patches/ exists, we apply all patches in that
339# directory, provided they follow this format:
340# @CODE
341# - Monolithic ebuilds, (from kde-base)
342# - $CATEGORY=kde-base:
343# Apply ${CHILD_EBUILD_NAME}-${SLOT}-*{diff,patch}
344# - $CATEGORY=!kde-base:
345# Apply ${CHILD_EBUILD_NAME}-${PV}-*{diff,patch}
346# - Split ebuilds:
347# - $CATEGORY=kde-base:
348# Apply ${PN}-${SLOT}-*{diff,patch}
349# - $CATEGORY!=kde-base:
350# Apply ${PN}-${PV}-*{diff,patch}
351# @CODE
352#
353# If ${PATCHES} is non-zero all patches in it get applied. If there is more
354# than one patch please make ${PATCHES} an array for proper quoting.
355kde4-base_apply_patches() {
356 local _patchdir _packages _p
357 _patchdir="${WORKDIR}/patches/"
358 if [[ -d "${_patchdir}" ]]; then
359 if is-parent-package ${CATEGORY}/${PN} ; then
360 _packages="$(get-child-packages ${CATEGORY}/${PN})"
361 _packages="${_packages//${CATEGORY}\//} ${PN}"
362 else
363 _packages="${PN}"
364 fi
365 if [[ ${#PATCHES[@]} -gt 1 ]]; then
366 for _p in ${_packages}; do
367 PATCHES=( "${PATCHES[@]}" $(ls ${_patchdir}/${_p}-${PV}-*{diff,patch} 2>/dev/null) )
368 if [[ -n "${KDEBASE}" ]]; then
369 PATCHES=( "${PATCHES[@]}" $(ls ${_patchdir}/${_p}-${SLOT}-*{diff,patch} 2>/dev/null) )
370 fi
371 done
372 else
373 for _p in ${_packages}; do
374 PATCHES=(${PATCHES} $(ls ${_patchdir}/${_p}-${PV}-*{diff,patch} 2>/dev/null))
375 if [[ -n "${KDEBASE}" ]]; then
376 PATCHES=(${PATCHES} $(ls ${_patchdir}/${_p}-${SLOT}-*{diff,patch} 2>/dev/null))
377 fi
378 done
379 fi
380 fi
381 [[ -n ${PATCHES[@]} ]] && base_src_unpack autopatch
382}
383
384# @FUNCTION: kde4-base_src_unpack 659# @FUNCTION: kde4-base_src_prepare
385# @DESCRIPTION: 660# @DESCRIPTION:
386# This function unpacks the source tarballs for KDE4 applications. 661# General pre-configure and pre-compile function for KDE4 applications.
387#
388# If no argument is passed to this function, then standard src_unpack is
389# executed. Otherwise options are passed to base_src_unpack.
390#
391# In addition it calls kde4-base_apply_patches when no arguments are passed to
392# this function.
393#
394# It also handles translations if KDE_LINGUAS is defined. See KDE_LINGUAS and 662# It also handles translations if KDE_LINGUAS is defined. See KDE_LINGUAS and
663# enable_selected_linguas() and enable_selected_doc_linguas()
395# enable_selected_linguas() in kde4-functions.eclass(5) for further details. 664# in kde4-functions.eclass(5) for further details.
396kde4-base_src_unpack() { 665kde4-base_src_prepare() {
397 debug-print-function $FUNCNAME "$@" 666 debug-print-function ${FUNCNAME} "$@"
398 667
399 [[ -z "${KDE_S}" ]] && KDE_S="${S}" 668 # enable handbook and linguas only when not using live ebuild
400
401 if [[ -z $* ]]; then
402 # Unpack first and deal with KDE patches after examing possible patch sets.
403 # To be picked up, patches need to conform to the guidelines stated before.
404 # Monolithic ebuilds will use the split ebuild patches.
405 [[ -d "${KDE_S}" ]] || unpack ${A}
406 kde4-base_apply_patches
407 else
408 # Call base_src_unpack, which unpacks and patches
409 # step by step transparently as defined in the ebuild.
410 base_src_unpack $*
411 fi
412
413 # Updated cmake dir
414 if [[ -d "${WORKDIR}/cmake" ]] && [[ -d "${KDE_S}/cmake" ]]; then
415 ebegin "Updating cmake/ directory..."
416 rm -rf "${KDE_S}/cmake" || die "Unable to remove old cmake/ directory"
417 ln -s "${WORKDIR}/cmake" "${KDE_S}/cmake" || die "Unable to symlink the new cmake/ directory"
418 eend 0
419 fi
420 669
421 # Only enable selected languages, used for KDE extragear apps. 670 # Only enable selected languages, used for KDE extragear apps.
422 if [[ -n ${KDE_LINGUAS} ]]; then 671 if [[ -n ${KDE_LINGUAS} ]]; then
423 enable_selected_linguas 672 enable_selected_linguas
424 fi 673 fi
674
675 # Enable/disable handbooks for kde4-base packages
676 # kde-l10n inherits kde4-base but is metpackage, so no check for doc
677 # kdelibs inherits kde4-base but handle installing the handbook itself
678 if ! has kde4-meta ${INHERITED} && in_iuse handbook; then
679 if [[ ${KDEBASE} == kde-base ]]; then
680 if [[ ${PN} != kde-l10n && ${PN} != kdepim-l10n && ${PN} != kdelibs ]] && use !handbook; then
681 # documentation in kde4-functions
682 : ${KDE_DOC_DIRS:=doc}
683 local dir
684 for dir in ${KDE_DOC_DIRS}; do
685 sed -e "\!^[[:space:]]*add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
686 -e "\!^[[:space:]]*ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
687 -e "\!^[[:space:]]*macro_optional_add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
688 -e "\!^[[:space:]]*MACRO_OPTIONAL_ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
689 -i CMakeLists.txt || die "failed to comment out handbook"
690 done
691 fi
692 else
693 enable_selected_doc_linguas
694 fi
695 fi
696
697 # SCM bootstrap
698 if [[ ${KDE_BUILD_TYPE} = live ]]; then
699 case ${KDE_SCM} in
700 svn) subversion_src_prepare ;;
701 esac
702 fi
703
704 # Apply patches
705 base_src_prepare
706
707 # Save library dependencies
708 if [[ -n ${KMSAVELIBS} ]] ; then
709 save_library_dependencies
710 fi
711
712 # Inject library dependencies
713 if [[ -n ${KMLOADLIBS} ]] ; then
714 load_library_dependencies
715 fi
716
717 # Hack for manuals relying on outdated DTD, only outside kde-base/...
718 if [[ -z ${KDEBASE} ]]; then
719 find "${S}" -name "*.docbook" \
720 -exec sed -i -r \
721 -e 's:-//KDE//DTD DocBook XML V4\.1(\..)?-Based Variant V1\.[01]//EN:-//KDE//DTD DocBook XML V4.2-Based Variant V1.1//EN:g' {} + \
722 || die 'failed to fix DocBook variant version'
723 fi
724}
725
726# @FUNCTION: kde4-base_src_configure
727# @DESCRIPTION:
728# Function for configuring the build of KDE4 applications.
729kde4-base_src_configure() {
730 debug-print-function ${FUNCNAME} "$@"
731
732 # Build tests in src_test only, where we override this value
733 local cmakeargs=(-DKDE4_BUILD_TESTS=OFF)
734
735 if use_if_iuse debug; then
736 # Set "real" debug mode
737 CMAKE_KDE_BUILD_TYPE="Debugfull"
738 else
739 # Handle common release builds
740 append-cppflags -DQT_NO_DEBUG
741 fi
742
743 # Set distribution name
744 [[ ${PN} = kdelibs ]] && cmakeargs+=(-DKDE_DISTRIBUTION_TEXT=Gentoo)
745
746 # Here we set the install prefix
747 tc-is-cross-compiler || cmakeargs+=(-DCMAKE_INSTALL_PREFIX="${EPREFIX}${PREFIX}")
748
749 # Use colors
750 QTEST_COLORED=1
751
752 # Shadow existing installations
753 unset KDEDIRS
754
755 #qmake -query QT_INSTALL_LIBS unavailable when cross-compiling
756 tc-is-cross-compiler && cmakeargs+=(-DQT_LIBRARY_DIR=${ROOT}/usr/$(get_libdir)/qt4)
757 #kde-config -path data unavailable when cross-compiling
758 tc-is-cross-compiler && cmakeargs+=(-DKDE4_DATA_DIR=${ROOT}/usr/share/apps/)
759
760 # sysconf needs to be /etc, not /usr/etc
761 cmakeargs+=(-DSYSCONF_INSTALL_DIR="${EPREFIX}"/etc)
762
763 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
764 if [[ ${mycmakeargs} ]]; then
765 eqawarn "mycmakeargs should always be declared as an array, not a string"
766 fi
767 mycmakeargs=(${mycmakeargs})
768 fi
769
770 mycmakeargs=("${cmakeargs[@]}" "${mycmakeargs[@]}")
771
772 cmake-utils_src_configure
425} 773}
426 774
427# @FUNCTION: kde4-base_src_compile 775# @FUNCTION: kde4-base_src_compile
428# @DESCRIPTION: 776# @DESCRIPTION:
429# General function for compiling KDE4 applications. 777# General function for compiling KDE4 applications.
430kde4-base_src_compile() { 778kde4-base_src_compile() {
431 debug-print-function ${FUNCNAME} "$@" 779 debug-print-function ${FUNCNAME} "$@"
432 780
433 kde4-base_src_configure
434 kde4-base_src_make
435}
436
437# @FUNCTION: kde4-base_src_configure
438# @DESCRIPTION:
439# Function for configuring the build of KDE4 applications.
440kde4-base_src_configure() {
441 debug-print-function ${FUNCNAME} "$@"
442
443 # Final flag handling
444 if has kdeenablefinal ${IUSE//+} && use kdeenablefinal; then
445 echo "Activating enable-final flag"
446 mycmakeargs="${mycmakeargs} -DKDE4_ENABLE_FINAL=ON"
447 fi
448
449 # Enable generation of HTML handbook
450 if has htmlhandbook ${IUSE//+} && use htmlhandbook; then
451 echo "Enabling building of HTML handbook"
452 mycmakeargs="${mycmakeargs} -DKDE4_ENABLE_HTMLHANDBOOK=ON"
453 fi
454
455 # Build tests in src_test only, where we override this value
456 mycmakeargs="${mycmakeargs} -DKDE4_BUILD_TESTS=OFF"
457
458 # Set distribution name
459 [[ ${PN} == "kdelibs" ]] && mycmakeargs="${mycmakeargs} -DKDE_DISTRIBUTION_TEXT=Gentoo"
460
461 # runpath linking
462 mycmakeargs="${mycmakeargs} -DKDE4_USE_ALWAYS_FULL_RPATH=ON"
463
464 # Here we set the install prefix
465 mycmakeargs="${mycmakeargs} -DCMAKE_INSTALL_PREFIX=${PREFIX}"
466
467 # Set environment
468 QTEST_COLORED=1
469 QT_PLUGIN_PATH=${KDEDIR}/$(get_libdir)/kde4/plugins/
470
471 cmake-utils_src_configureout
472}
473
474# @FUNCTION: kde4-base_src_make
475# @DESCRIPTION:
476# Function for building KDE4 applications.
477# Options are passed to cmake-utils_src_make.
478kde4-base_src_make() {
479 debug-print-function ${FUNCNAME} "$@"
480
481 cmake-utils_src_make "$@" 781 cmake-utils_src_compile "$@"
482} 782}
483 783
484# @FUNCTION: kde4-base_src_test 784# @FUNCTION: kde4-base_src_test
485# @DESCRIPTION: 785# @DESCRIPTION:
486# Function for testing KDE4 applications. 786# Function for testing KDE4 applications.
487kde4-base_src_test() { 787kde4-base_src_test() {
488 debug-print-function ${FUNCNAME} "$@" 788 debug-print-function ${FUNCNAME} "$@"
489 789
790 local kded4_pid
791
792 _test_runner() {
793 if [[ -n "${VIRTUALDBUS_TEST}" ]]; then
794 export $(dbus-launch)
795 kded4 2>&1 > /dev/null &
796 kded4_pid=$!
797 fi
798
799 cmake-utils_src_test
800 }
801
802 # When run as normal user during ebuild development with the ebuild command, the
803 # kde tests tend to access the session DBUS. This however is not possible in a real
804 # emerge or on the tinderbox.
805 # > make sure it does not happen, so bad tests can be recognized and disabled
806 unset DBUS_SESSION_BUS_ADDRESS DBUS_SESSION_BUS_PID
807
490 # Override this value, set in kde4-base_src_configure() 808 # Override this value, set in kde4-base_src_configure()
491 mycmakeargs="${mycmakeargs} -DKDE4_BUILD_TESTS=ON" 809 mycmakeargs+=(-DKDE4_BUILD_TESTS=ON)
492 cmake-utils_src_compile 810 cmake-utils_src_configure
811 kde4-base_src_compile
493 812
494 cmake-utils_src_test 813 if [[ ${VIRTUALX_REQUIRED} == always || ${VIRTUALX_REQUIRED} == test ]]; then
814 # check for sanity if anyone already redefined VIRTUALX_COMMAND from the default
815 if [[ ${VIRTUALX_COMMAND} != emake ]]; then
816 # surprise- we are already INSIDE virtualmake!!!
817 debug-print "QA Notice: This version of kde4-base.eclass includes the virtualx functionality."
818 debug-print " You may NOT set VIRTUALX_COMMAND or call virtualmake from the ebuild."
819 debug-print " Setting VIRTUALX_REQUIRED is completely sufficient. See the"
820 debug-print " kde4-base.eclass docs for details... Applying workaround."
821 _test_runner
822 else
823 VIRTUALX_COMMAND="_test_runner" virtualmake
824 fi
825 else
826 _test_runner
827 fi
828
829 if [ -n "${kded4_pid}" ] ; then
830 kill ${kded4_pid}
831 fi
832
833 if [ -n "${DBUS_SESSION_BUS_PID}" ] ; then
834 kill ${DBUS_SESSION_BUS_PID}
835 fi
495} 836}
496 837
497# @FUNCTION: kde4-base_src_install 838# @FUNCTION: kde4-base_src_install
498# @DESCRIPTION: 839# @DESCRIPTION:
499# Function for installing KDE4 applications. 840# Function for installing KDE4 applications.
500kde4-base_src_install() { 841kde4-base_src_install() {
501 debug-print-function ${FUNCNAME} "$@" 842 debug-print-function ${FUNCNAME} "$@"
502 843
503 kde4-base_src_make_doc 844 if [[ -n ${KMSAVELIBS} ]] ; then
845 install_library_dependencies
846 fi
847
848 # Install common documentation of KDE4 applications
849 local doc
850 if ! has kde4-meta ${INHERITED}; then
851 for doc in "${S}"/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
852 [[ -f ${doc} && -s ${doc} ]] && dodoc "${doc}"
853 done
854 for doc in "${S}"/*/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
855 [[ -f ${doc} && -s ${doc} ]] && newdoc "${doc}" "$(basename $(dirname ${doc})).$(basename ${doc})"
856 done
857 fi
858
504 cmake-utils_src_install 859 cmake-utils_src_install
505}
506 860
507# @FUNCTION: kde4-base_src_make_doc 861 # In EAPI 4+, we don't want ${PREFIX}/share/doc/HTML to be compressed,
508# @DESCRIPTION: 862 # because then khelpcenter can't find the docs
509# Function for installing the documentation of KDE4 applications. 863 [[ ${EAPI:-0} != 3 && -d ${ED}/${PREFIX}/share/doc/HTML ]] &&
510kde4-base_src_make_doc() { 864 docompress -x ${PREFIX}/share/doc/HTML
511 debug-print-function ${FUNCNAME} "$@" 865}
512 866
513 local doc 867# @FUNCTION: kde4-base_pkg_preinst
514 for doc in AUTHORS ChangeLog* README* NEWS TODO; do 868# @DESCRIPTION:
515 [[ -s $doc ]] && dodoc ${doc} 869# Function storing icon caches
516 done 870kde4-base_pkg_preinst() {
871 debug-print-function ${FUNCNAME} "$@"
517 872
518 if [[ -z ${KMNAME} ]]; then 873 gnome2_icon_savelist
519 for doc in {apps,runtime,workspace,.}/*/{AUTHORS,README*}; do 874 if [[ ${KDE_BUILD_TYPE} == live && ${KDE_SCM} == svn ]]; then
520 if [[ -s $doc ]]; then 875 subversion_pkg_preinst
521 local doc_complete=${doc}
522 doc="${doc#*/}"
523 newdoc "$doc_complete" "${doc%/*}.${doc##*/}"
524 fi
525 done
526 fi
527
528 if [[ -n ${KDEBASE} && -d "${D}"/usr/share/doc/${PF} ]]; then
529 # work around bug #97196
530 dodir /usr/share/doc/kde && \
531 mv "${D}"/usr/share/doc/${PF} "${D}"/usr/share/doc/kde/ || \
532 die "Failed to move docs to kde/ failed."
533 fi 876 fi
534} 877}
535 878
536# @FUNCTION: kde4-base_pkg_postinst 879# @FUNCTION: kde4-base_pkg_postinst
537# @DESCRIPTION: 880# @DESCRIPTION:
538# Function to rebuild the KDE System Configuration Cache after an application has been installed. 881# Function to rebuild the KDE System Configuration Cache after an application has been installed.
539kde4-base_pkg_postinst() { 882kde4-base_pkg_postinst() {
883 debug-print-function ${FUNCNAME} "$@"
884
885 gnome2_icon_cache_update
886 fdo-mime_desktop_database_update
887 fdo-mime_mime_database_update
540 buildsycoca 888 buildsycoca
889
890 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
891 if [[ ${KDE_BUILD_TYPE} = live ]]; then
892 echo
893 einfo "WARNING! This is an experimental live ebuild of ${CATEGORY}/${PN}"
894 einfo "Use it at your own risk."
895 einfo "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!"
896 echo
897 fi
898 # for all 3rd party soft tell user that he SHOULD install kdebase-startkde or kdebase-runtime-meta
899 if [[ ${KDEBASE} != kde-base ]] && \
900 ! has_version 'kde-base/kdebase-runtime-meta' && \
901 ! has_version 'kde-base/kdebase-startkde'; then
902 if [[ ${KDE_REQUIRED} == always ]] || ( [[ ${KDE_REQUIRED} == optional ]] && use kde ); then
903 echo
904 ewarn "WARNING! Your system configuration contains neither \"kde-base/kdebase-runtime-meta\""
905 ewarn "nor \"kde-base/kdebase-startkde\". You need one of above."
906 ewarn "With this setting you are unsupported by KDE team."
907 ewarn "All missing features you report for misc packages will be probably ignored or closed as INVALID."
908 fi
909 fi
910 fi
541} 911}
542 912
543# @FUNCTION: kde4-base_pkg_postrm 913# @FUNCTION: kde4-base_pkg_postrm
544# @DESCRIPTION: 914# @DESCRIPTION:
545# Function to rebuild the KDE System Configuration Cache after an application has been removed. 915# Function to rebuild the KDE System Configuration Cache after an application has been removed.
546kde4-base_pkg_postrm() { 916kde4-base_pkg_postrm() {
917 debug-print-function ${FUNCNAME} "$@"
918
919 gnome2_icon_cache_update
920 fdo-mime_desktop_database_update
921 fdo-mime_mime_database_update
547 buildsycoca 922 buildsycoca
548} 923}

Legend:
Removed from v.1.9  
changed lines
  Added in v.1.121

  ViewVC Help
Powered by ViewVC 1.1.20